%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                      PSG Type    PSG Object             Location in Problem Statement                              Class
%matrix_syi_112_data         data        matrix_syi_112         n/a                                                        double
%matrix_syi_112_vars         vars        matrix_syi_112         n/a                                                        cell
%matrix_xyi_norm_112_data    data        matrix_xyi_norm_112    n/a                                                        double
%matrix_xyi_norm_112_vars    vars        matrix_xyi_norm_112    n/a                                                        cell
%vector_qi_data              data        vector_qi              ksm_avg(matrix_xYi_norm_112, vector_Yi_norm, vector_qi)    double
%vector_alp_data             data        vector_alp             pcvar(vector_alp,matrix_xYi_norm_112)                      double
%vector_cvars_y_data         data        vector_cvars_y         n/a                                                        double
%vector_yi_norm_data         data        vector_yi_norm         n/a                                                        double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = problem_ksmavg_cvar_equality_subroutine(matrix_syi_112_data,matrix_syi_112_vars,matrix_xyi_norm_112_data,matrix_xyi_norm_112_vars,vector_qi_data,vector_alp_data,vector_cvars_y_data,vector_yi_norm_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_syi_112',matrix_syi_112_data,matrix_syi_112_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_xyi_norm_112',matrix_xyi_norm_112_data,matrix_xyi_norm_112_vars,[],[]);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_qi',vector_qi_data);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_alp',vector_alp_data);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_cvars_y',vector_cvars_y_data);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_yi_norm',vector_yi_norm_data);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'problem_KSMavg_Cvar_equality, minimize',...
'linearize = 1',...
'  ksm_avg(matrix_xYi_norm_112, vector_Yi_norm, vector_qi)',...
'constraint: = 1',...
'  linear(matrix_sYi_112)',...
'multiconstraint: = vector_cvars_Y, linearize = 1',...
' pcvar(vector_alp,matrix_xYi_norm_112)',...
'box: >= 0, <= 1',...
'solver: car',...
'',...
' ');
%Change parameters with their values in problem statement:

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

